package com.base.scanqrclear.ui.email

import android.content.Intent
import androidx.activity.addCallback
import androidx.core.view.updatePadding
import androidx.lifecycle.ViewModelProvider
import com.base.scanqrclear.R
import com.base.scanqrclear.ads.AdsMgr
import com.base.scanqrclear.ads.AdsShowCallBack
import com.base.scanqrclear.base.BaseActivity
import com.base.scanqrclear.bean.EmailUIBean
import com.base.scanqrclear.bean.EmailUIBean.Companion.createEmailQrString
import com.base.scanqrclear.bean.FunctionUIBean.Companion.KEY_EMAIL
import com.base.scanqrclear.bean.config.AdConfigBean
import com.base.scanqrclear.databinding.ActivityEmailCodeBinding
import com.base.scanqrclear.ui.exportpdf.ExportPdfActivity
import com.base.scanqrclear.ui.vm.QrViewModel
import com.base.scanqrclear.ui.widget.InputNameDialog.showInputNameDialog
import com.base.scanqrclear.utils.BarUtils
import com.base.scanqrclear.utils.BitmapUtils.saveBitmapToFile
import com.base.scanqrclear.utils.ClipboardUtils.copyText
import com.base.scanqrclear.utils.IntentUtils.intentSendEmail
import com.base.scanqrclear.utils.IntentUtils.intentShareImage
import com.base.scanqrclear.utils.LogEx
import com.base.scanqrclear.utils.QRCodeUtils.generateQRCode
import com.base.scanqrclear.utils.SpJsonUtils
import com.base.scanqrclear.utils.ToastUtils.toast
import com.google.gson.Gson
import java.io.File

class EmailCodeActivity : BaseActivity<ActivityEmailCodeBinding>(ActivityEmailCodeBinding::inflate) {

    private var email = EmailUIBean()
    private var tempImagePath: String = ""
    private var qrString: String = ""

    private val viewModel by lazy(LazyThreadSafetyMode.NONE) {
        ViewModelProvider(this)[QrViewModel::class.java]
    }

    override fun onResumeOneShoot() {
        super.onResumeOneShoot()
        val flag = changeLanguage()
        if (flag) return

        AdsMgr.showBanner(binding.flBanner, false)
    }

    override fun initView() {
        super.initView()
        binding.clTop.updatePadding(top = BarUtils.getStatusBarHeight())
        AdsMgr.showNative(binding.flAd, R.layout.layout_admob_item)

        val data = intent.extras?.getString("data")
        email = Gson().fromJson(data, EmailUIBean::class.java)

        binding.tvAddress.text = email.address
        binding.tvSubject.text = email.subject
        binding.tvMessage.text = email.message

        Thread {
            qrString = createEmailQrString(email)
            val bitmap = generateQRCode(qrString, 735, 735, 5)
            runOnUiThread {
                binding.ivQr.setImageBitmap(bitmap)
                val file = File(cacheDir, System.currentTimeMillis().toString() + ".jpg")
                bitmap?.let {
                    val flag = saveBitmapToFile(it, file.absolutePath)
                    LogEx.logDebug(TAG, "flag=$flag tempImage=${file.absolutePath}")
                    if (flag) {
                        tempImagePath = file.absolutePath
                    }
                }
                if (email.needCreate) {
                    email.needCreate = false
                    SpJsonUtils.addJsonBean<EmailUIBean>(KEY_EMAIL, email)
                }
            }
        }.start()

    }

    override fun initListener() {
        super.initListener()
        if (AdConfigBean.adsConfigBean.functionBackShowAd) {
            onBackPressedDispatcher.addCallback {
                AdsMgr.showInsert(this@EmailCodeActivity, false, object : AdsShowCallBack() {
                    override fun close(where: Int) {
                        finishToMainTop()
                    }

                    override fun failed(where: Int) {
                        finishToMainTop()
                    }

                    override fun googleFailed(where: Int) {
                        finishToMainTop()
                    }
                })
            }
        } else {
            finishToMainTop()
        }
        binding.flBack.setOnClickListener {
            onBackPressedDispatcher.onBackPressed()
        }

        binding.llShare.setOnClickListener {
            val intent = intentShareImage(this, tempImagePath)
            runCatching {
                startActivity(intent)
            }
        }
        binding.llPdf.setOnClickListener {
            startActivity(Intent(this, ExportPdfActivity::class.java).apply {
                putExtra("qrType", KEY_EMAIL)
                putExtra("qrString", qrString)
            })
        }
        binding.llDownload.setOnClickListener {
            if (AdConfigBean.adsConfigBean.functionUseShowAd) {
                AdsMgr.showInsert(this, true, object : AdsShowCallBack() {
                    override fun close(where: Int) {
                        useDownload()
                    }

                    override fun failed(where: Int) {
                        useDownload()
                    }

                    override fun googleFailed(where: Int) {
                        useDownload()
                    }
                })
            } else {
                useDownload()
            }
        }
        binding.llCopy.setOnClickListener {
            copyText(TAG, qrString)
            toast("Copied to clipboard", true)
        }
        binding.flSearch.setOnClickListener {
            if (AdConfigBean.adsConfigBean.functionUseShowAd) {
                AdsMgr.showInsert(this, true, object : AdsShowCallBack() {
                    override fun close(where: Int) {
                        useSearch()
                    }

                    override fun failed(where: Int) {
                        useSearch()
                    }

                    override fun googleFailed(where: Int) {
                        useSearch()
                    }
                })
            } else {
                useSearch()
            }
        }
    }

    fun useDownload() {
        kotlin.runCatching {
            val newName = File(tempImagePath).name
            showInputNameDialog(newName) { name ->
                viewModel.copyFileToDownloads(this, name, tempImagePath)
            }
        }
    }

    fun useSearch() {
        val intent = intentSendEmail(email)
        try {
            startActivity(intent)
        } catch (e: Exception) {
            toast("No application was found to handle the email request", true)
        }
    }

}